﻿using FarPoint.Win.Spread;
using FarPoint.Win.Spread.Chart;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SpreadSparkline
{
    public partial class Form1 : Form
    {
        private FpSpread fpSpread1;
        private SheetView fpSpread1_Sheet1;

        public Form1()
        {
            InitializeComponent();
        }
        class CustomExcelSparkline : ExcelSparkline
        {
            CellRangeSegmentData innerData;
            public CustomExcelSparkline(int row, int column, SheetView source)
                : base(row, column, string.Empty)
            {
                innerData = new CellRangeSegmentData(source, 0, 0, source.RowCount, source.ColumnCount, null);
            }
            public override object GetSparkLineData()
            {
                return innerData;
            }
        }

        private void InitializeComponent()
        {
            this.fpSpread1 = new FarPoint.Win.Spread.FpSpread();
            this.fpSpread1_Sheet1 = new FarPoint.Win.Spread.SheetView();
            ((System.ComponentModel.ISupportInitialize)(this.fpSpread1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.fpSpread1_Sheet1)).BeginInit();
            this.SuspendLayout();
            // 
            // fpSpread1
            // 
            this.fpSpread1.AccessibleDescription = "";
            this.fpSpread1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.fpSpread1.Location = new System.Drawing.Point(0, 0);
            this.fpSpread1.Name = "fpSpread1";
            this.fpSpread1.Sheets.AddRange(new FarPoint.Win.Spread.SheetView[] {
            this.fpSpread1_Sheet1});
            this.fpSpread1.Size = new System.Drawing.Size(883, 521);
            this.fpSpread1.TabIndex = 0;
            // 
            // fpSpread1_Sheet1
            // 
            this.fpSpread1_Sheet1.Reset();
            this.fpSpread1_Sheet1.SheetName = "Sheet1";
            // 
            // Form1
            // 
            this.ClientSize = new System.Drawing.Size(883, 521);
            this.Controls.Add(this.fpSpread1);
            this.Name = "Form1";
            this.Text = "SpreadSparkline";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.fpSpread1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.fpSpread1_Sheet1)).EndInit();
            this.ResumeLayout(false);

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            fpSpread1.SuspendLayout();
            List<Double> dlist = new List<double>();
            dlist.Add(4.5);
            dlist.Add(4.8);
            dlist.Add(5.5);
            dlist.Add(6.0);
            dlist.Add(7.5);

            SheetView sv = new SheetView();
            sv.Visible = false;
            sv.SheetName = Guid.NewGuid().ToString();
            sv.DataSource = dlist;
            fpSpread1.Sheets.Add(sv);
            fpSpread1.Sheets[0].RowCount = 10;
            fpSpread1.Sheets[0].ColumnCount = 10;
            for (int r = 0; r < fpSpread1.Sheets[0].RowCount; r++)
            {
                FarPoint.Win.Spread.SparklineType type = SparklineType.Column;
                if (r % 3 == 1)
                    type = SparklineType.Line;
                else if (r % 3 == 2)
                    type = SparklineType.Winloss;
                FarPoint.Win.Spread.ExcelSparklineGroup esg = new FarPoint.Win.Spread.ExcelSparklineGroup(new FarPoint.Win.Spread.ExcelSparklineSetting(), type);
                for (int c = 0; c < fpSpread1.Sheets[0].ColumnCount; c++)
                {
                    CustomExcelSparkline es = new CustomExcelSparkline(r, c, sv);
                    esg.Add(es);
                }
                fpSpread1.Sheets[0].SparklineContainer.Add(esg);
            }
            fpSpread1.ResumeLayout();
        }
    }
}
